package com.example.fuzzControll.controller.dataController;

import com.example.fuzzControll.domain.bo.AflnetDataParams;
import com.example.fuzzControll.domain.vo.AjaxResult;
import com.example.fuzzControll.service.AflnetPersistenceService;
import com.example.fuzzControll.service.TestService;
import com.example.fuzzControll.tools.test.TestCmdTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/aflnet")
@Slf4j
public class AflnetDataController {
    @Autowired
    AflnetPersistenceService aflnetPersistenceService;
    @Autowired
    TestService testService;
    TestCmdTools testCmdTools = new TestCmdTools();

    /**
     * 读取数据库文件至指定目录
     */
    @RequestMapping(value = "/loadFile", method = RequestMethod.GET)
    public AjaxResult AflnetResultSelect(@RequestBody AflnetDataParams aflnetDataParams) {
        try {
            aflnetPersistenceService.loadInFile(aflnetDataParams.getMissionId(), aflnetDataParams.getFilPath());
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error("File load failed!");
        }
        return AjaxResult.success("File loaded successfully!");
    }

    /**
     * 异常重放（查看堆栈）
     */
    @RequestMapping(value = "/replay", method = RequestMethod.GET)
    public AjaxResult replay(@RequestParam String programPath) {
        try {
            new Thread(new Runnable() {
                @Override
                public void run() {
                    testService.replay(programPath);
                }
            }).start();
            Thread.sleep(1000);
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error("Replay failed!");
        }
        return AjaxResult.success("Start replay success!");
    }

    /**
     * 读取异常定位分析结果
     */
    @RequestMapping(value = "/getreplayresult", method = RequestMethod.GET)
    public AjaxResult readReplayResult() {
        List<String> result = new ArrayList<String>();
        try {
            result = testService.getReplayResult();
        } catch (Exception e) {
            return AjaxResult.error("Get replayResult failed!");
        }
        return AjaxResult.success(result);
    }
}
